GNU bug report logs - #17792
24.3; hintstyle specified via fontconfig is ignored by Emacs

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: yynyygy@HIDDEN; dated Tue, 17 Jun 2014 03:10:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 17792 <at> debbugs.gnu.org:


Received: (at 17792) by debbugs.gnu.org; 25 Jun 2014 08:32:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 25 04:32:29 2014
Received: from localhost ([127.0.0.1]:59923 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Wzid2-0000Si-HG
	for submit <at> debbugs.gnu.org; Wed, 25 Jun 2014 04:32:28 -0400
Received: from mailfe02.swip.net ([212.247.154.33]:48073 helo=swip.net)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jan.h.d@HIDDEN>) id 1Wzicy-0000SI-U5
 for 17792 <at> debbugs.gnu.org; Wed, 25 Jun 2014 04:32:26 -0400
X-T2-Spam-Status: No, hits=0.0 required=5.0
Received: from hosdjarv.se (account mj138573@HIDDEN [46.59.42.57] verified)
 by mailfe02.swip.net (CommuniGate Pro SMTP 5.4.4)
 with ESMTPA id 512494970; Wed, 25 Jun 2014 10:32:17 +0200
Content-Type: text/plain; charset=iso-8859-1
Mime-Version: 1.0 (Mac OS X Mail 7.3 \(1878.2\))
Subject: Re: bug#17792: 24.3;
 hintstyle spewcified via fontconfig is ignored by Emacs
From: =?iso-8859-1?Q?Jan_Dj=E4rv?= <jan.h.d@HIDDEN>
In-Reply-To: <m338euarva.fsf@HIDDEN>
Date: Wed, 25 Jun 2014 10:32:16 +0200
Content-Transfer-Encoding: quoted-printable
Message-Id: <A0A32C4D-14F9-4BD3-B575-E3E24E79D4B2@HIDDEN>
References: <53A70B0B.3050300@HIDDEN>
 <E50C4E87-39F2-45C7-8F4E-BD0089858B5F@HIDDEN>
 <m338euarva.fsf@HIDDEN>
To: James Cloos <cloos@HIDDEN>
X-Mailer: Apple Mail (2.1878.2)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 17792
Cc: 17792 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Hello.

25 jun 2014 kl. 00:01 skrev James Cloos <cloos@HIDDEN>:

>>>>>> "JD" =3D=3D Jan Dj=E4rv <jan.h.d@HIDDEN> writes:
>=20
> JD> I don't know if cairo itself reads fonts.conf and/or X resources,
> JD> but I suspect it does.
>=20
> No.  It uses the fontconfig api.

Thanks for the clarification.

>=20
> This bug is a side effect of using xft to render fonts.  LibXft has a
> routine which edits the font pattern before passing on to =
libfontconfig;
> it adds pattern elements for each of:
>=20
>  antialias autohint dpi embolden hinting hintstyle lcdfilter
>  maxglyphmemory maxunreffonts minspace render rgba scale
>=20
> based on what it finds in the X Resources.
>=20
> It always adds a pattern entry for each of those, with a default value
> if it doesn't find an explicit X resource.
>=20
> Fontconfig is written to allow applications to override the default
> values specified in/via fonts.conf, on the reasonable theories that =
users
> should be able to tell apps to override them, and that some =
applications
> SHOULD avoid things like hinting, and therefore need a way to do that.
>=20
> By forcing its own set of defaults, xft blocks any ability to set =
those
> via the xml.
>=20
> Fixing this will either require changing libxft to avoid adding =
pattern
> elements for which explicit X Resources do not exist, or changing =
Emacs
> to use fontconfig, freetype and XRENDER directly, rather than via xft.
>=20
> Handa-san's original code supported an fc: prefix for fonts, which was
> defined to do the above, but the xft: won out.


Emacs does have the ftx font backend that gets compiled if libXft is not =
present.
Unfortunately it seems a bit broken w.r.t. sizes (all fonts are too =
large), and also the Gtk+ code in Emacs assumes Xft.  Both of these =
could be fixed, and we could offer both backends.

Ftx does not use XRENDER btw, so I suspect it might be a bit slow.
Another approach would be to add a draw method to the Ft backend.  =
Currently it is just common code for Xft and ftx.

But it seems excessive to work around something that can be made to work =
anyway.

	Jan D.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#17792; Package emacs. Full text available.

Message received at 17792 <at> debbugs.gnu.org:


Received: (at 17792) by debbugs.gnu.org; 24 Jun 2014 22:16:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 24 18:16:15 2014
Received: from localhost ([127.0.0.1]:59722 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1WzZ0d-0007a0-Oc
	for submit <at> debbugs.gnu.org; Tue, 24 Jun 2014 18:16:15 -0400
Received: from ore.jhcloos.com ([198.147.23.85]:42450)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <cloos@HIDDEN>) id 1WzZ0X-0007Zh-NM
 for 17792 <at> debbugs.gnu.org; Tue, 24 Jun 2014 18:16:09 -0400
Received: by ore.jhcloos.com (Postfix, from userid 10)
 id 754C61E5CD; Tue, 24 Jun 2014 22:16:04 +0000 (UTC)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=jhcloos.com;
 s=ore14; t=1403648164;
 bh=n9jzLm74K6qx+6GBo64i8BygK2nTUhalFWRnZWZA3pw=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=Og1hPXwFh3tg89I8VyXeCVq3bhrVHYSnDaX5A7z/LzAB+Sa51Tj39I7oVjfAPatoj
 JUIRB9/lK/epZ5XPMRhDbgosnEPV2eFgqqR1e3Xa9WR4ExSXWExhRLFf67xkUsC2tb
 xsRVCnoOz1bV0PLZ6ilchAUL8pB7RyGVIrlZRKjM=
Received: by carbon.jhcloos.org (Postfix, from userid 500)
 id 052F66001E; Tue, 24 Jun 2014 22:02:17 +0000 (UTC)
From: James Cloos <cloos@HIDDEN>
To: Jan =?iso-8859-1?Q?Dj=E4rv?= <jan.h.d@HIDDEN>
Subject: Re: bug#17792: 24.3;
 hintstyle spewcified via fontconfig is ignored by Emacs
In-Reply-To: <E50C4E87-39F2-45C7-8F4E-BD0089858B5F@HIDDEN> ("Jan
 =?iso-8859-1?Q?Dj=E4rv=22's?=
 message of "Sun, 22 Jun 2014 22:54:14 +0200")
References: <53A70B0B.3050300@HIDDEN>
 <E50C4E87-39F2-45C7-8F4E-BD0089858B5F@HIDDEN>
User-Agent: Gnus/5.130012 (Ma Gnus v0.12) Emacs/24.4.50 (gnu/linux)
Face: iVBORw0KGgoAAAANSUhEUgAAABAAAAAQAgMAAABinRfyAAAACVBMVEX///8ZGXBQKKnCrDQ3
 AAAAJElEQVQImWNgQAAXzwQg4SKASgAlXIEEiwsSIYBEcLaAtMEAADJnB+kKcKioAAAAAElFTkSu
 QmCC
Copyright: Copyright 2014 James Cloos
OpenPGP: 0x997A9F17ED7DAEA6;
 url=https://jhcloos.com/public_key/0x997A9F17ED7DAEA6.asc
OpenPGP-Fingerprint: E9E9 F828 61A4 6EA9 0F2B  63E7 997A 9F17 ED7D AEA6
Date: Tue, 24 Jun 2014 18:01:52 -0400
Message-ID: <m338euarva.fsf@HIDDEN>
Lines: 37
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-Hashcash: 1:30:140624:jan.h.d@HIDDEN::2usZDEZxPiDYZWlZ:000000000000000000000000000000000000000000VECR7
X-Hashcash: 1:30:140624:17792 <at> debbugs.gnu.org::8sMpqGN/oaqWuah6:0000000000000000000000000000000000000004VH+o
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 17792
Cc: 17792 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

>>>>> "JD" == Jan Djärv <jan.h.d@HIDDEN> writes:

JD> I don't know if cairo itself reads fonts.conf and/or X resources,
JD> but I suspect it does.

No.  It uses the fontconfig api.

This bug is a side effect of using xft to render fonts.  LibXft has a
routine which edits the font pattern before passing on to libfontconfig;
it adds pattern elements for each of:

  antialias autohint dpi embolden hinting hintstyle lcdfilter
  maxglyphmemory maxunreffonts minspace render rgba scale

based on what it finds in the X Resources.

It always adds a pattern entry for each of those, with a default value
if it doesn't find an explicit X resource.

Fontconfig is written to allow applications to override the default
values specified in/via fonts.conf, on the reasonable theories that users
should be able to tell apps to override them, and that some applications
SHOULD avoid things like hinting, and therefore need a way to do that.

By forcing its own set of defaults, xft blocks any ability to set those
via the xml.

Fixing this will either require changing libxft to avoid adding pattern
elements for which explicit X Resources do not exist, or changing Emacs
to use fontconfig, freetype and XRENDER directly, rather than via xft.

Handa-san's original code supported an fc: prefix for fonts, which was
defined to do the above, but the xft: won out.

-JimC
-- 
James Cloos <cloos@HIDDEN>         OpenPGP: 0x997A9F17ED7DAEA6




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#17792; Package emacs. Full text available.

Message received at 17792 <at> debbugs.gnu.org:


Received: (at 17792) by debbugs.gnu.org; 22 Jun 2014 20:54:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jun 22 16:54:25 2014
Received: from localhost ([127.0.0.1]:57392 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1WyomP-0003rl-7W
	for submit <at> debbugs.gnu.org; Sun, 22 Jun 2014 16:54:25 -0400
Received: from mailfe04.swip.net ([212.247.154.97]:38799 helo=swip.net)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jan.h.d@HIDDEN>) id 1WyomM-0003rU-H4
 for 17792 <at> debbugs.gnu.org; Sun, 22 Jun 2014 16:54:23 -0400
X-T2-Spam-Status: No, hits=0.8 required=5.0 tests=BAYES_50
Received: from hosdjarv.se (account mj138573@HIDDEN [46.59.42.57] verified)
 by mailfe04.swip.net (CommuniGate Pro SMTP 5.4.4)
 with ESMTPA id 509670424 for 17792 <at> debbugs.gnu.org;
 Sun, 22 Jun 2014 22:54:15 +0200
Subject: bug#17792: 24.3;
 hintstyle spewcified via fontconfig is ignored by Emacs
References: <53A70B0B.3050300@HIDDEN>
From: =?utf-8?Q?Jan_Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Content-Type: text/plain;
	charset=utf-8
X-Mailer: iPhone Mail (11D201)
Message-Id: <E50C4E87-39F2-45C7-8F4E-BD0089858B5F@HIDDEN>
Date: Sun, 22 Jun 2014 22:54:14 +0200
To: 17792 <at> debbugs.gnu.org
Content-Transfer-Encoding: quoted-printable
Mime-Version: 1.0 (1.0)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 17792
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

2014-06-18 06:44, Fangwen Yu skrev:
> Clearly the fontconfig version on my system understands hint setting. As I=

> have said, if I have hintnone in fonts.conf and hintslight in X
> resources, Emacs will use hintslight and all other gtk applications like
> gedit, gnome-terminal will use hintnone.

It isn't about the fontconfig you have in the system when you run Emacs, it i=
s about the fontconfig used to compile Emacs and libXft.

To repeat, Emacs only applies settings from GSettings, Xsettings and GConf.
fonts.conf and X resources are not read by any Emacs code, it is all done in=
 library code.
So if you want to change something for Emacs, you must make sure it also get=
s changed in one of the places Emacs reads, which is not fonts.conf or X res=
ources settings.

Gedit uses cairo, which in turn uses fontconfig and (possibly) libXft.
I don't know if cairo itself reads fonts.conf and/or X resources, but I susp=
ect it does.
Emacs does not use cairo, so if there are differences, it is not surprising.=



>=20
> Since Emacs is also a gtk application, why doesn't it respect fontconfig s=
ettings?

Emacs is not a Gtk+ application in any sense of the word, it just uses part o=
f its widget set in one of its configurations.  Emacs does not use rendering=
 like Gtk+ programs do, it does not use the same configuration mechanisms ei=
ther.
It also violates about every Gtk+ guideline for a good Gtk+ program...

   Jan D.


>=20
>=20
> On Tue, Jun 17, 2014 at 11:28 PM, Jan Dj=C3=A4rv <jan.h.d@HIDDEN
> <mailto:jan.h.d@HIDDEN>> wrote:
>=20
>    Hello.
>=20
>    17 jun 2014 kl. 05:08 skrev yynyygy@HIDDEN <mailto:yynyygy@HIDDEN=
>:
>=20
>     > I've noticed font rendering differences between Emacs and other gtk
>     > applications like gedit. In short, Emacs ignores hintstyle setting i=
n
>     > fontconfig. I have hintstyle set to hintslight in
>     > ~/.config/fontconfig/fonts.conf, but I have to add 'Xft.hintstyle:
>     > hintslight' in Xresources to get the desired effect.
>     >
>     > The strange thing is that while ignoring hintstyle setting, Emacs st=
ill
>     > respect part of fontconfig settings, for example, anti-aliasing sett=
ing
>     > in fonts.conf will affect Emacs's font rendering.
>     >
>=20
>    Hint setting is newer than the rest so it is possible your Emacs was
>    compiled against a fontconfig that don't have it.
>    Another possibility is that you have GSettings or GConf settings that a=
re
>    different than fonts.conf or from the X resources.
>=20
>    Emacs by itself does not read fonts.conf or apply X resources, it is al=
l
>    done by fontconfig/Xft-libraries.  Emacs do apply GSettings and/or GCon=
f
>    settings.
>=20
>             Jan D.
>=20
>=20
>     > To be more precise, if I disable anti-aliasing in fonts.conf and ena=
ble
>     > it in Xresources, Emacs will not have anti-aliasing; if I have
>     > hintslight in fonts.conf and hintnone in Xresources, Emacs will use
>     > hintnone.
>     >
>     > I have tested with DejaVu Sans Mono 12 and Ubuntu Mono 13, but clear=
ly
>     > it is not the fonts' problem.
>     >





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#17792; Package emacs. Full text available.

Message received at 17792 <at> debbugs.gnu.org:


Received: (at 17792) by debbugs.gnu.org; 18 Jun 2014 04:44:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Jun 18 00:44:16 2014
Received: from localhost ([127.0.0.1]:51080 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Wx7jL-0003qU-Cq
	for submit <at> debbugs.gnu.org; Wed, 18 Jun 2014 00:44:16 -0400
Received: from mail-pa0-f54.google.com ([209.85.220.54]:52963)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <yynyygy@HIDDEN>) id 1Wx7jG-0003qD-Ob
 for 17792 <at> debbugs.gnu.org; Wed, 18 Jun 2014 00:44:12 -0400
Received: by mail-pa0-f54.google.com with SMTP id et14so311225pad.13
 for <17792 <at> debbugs.gnu.org>; Tue, 17 Jun 2014 21:44:04 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=mime-version:in-reply-to:references:date:message-id:subject:from:to
 :cc:content-type;
 bh=C9rUezm82Ez6L5bwfiXfzAZQe1FUOZsVXc1O6ygUvbc=;
 b=vueFBOuvc7f2vmrE/Usw4z7zk0oRIPDUa7Rx9ZEdF6hTEqHBibj6+yf355zWJlQN9W
 UK06J0UeU0Vx9Gyf0XoVfy0EvJWuQW3FyMmgKDytPtHN3zZr+dezNI8Its01ZS7JWqmv
 19LFEkzY8XwceOsAjrrI9gJ8/VNMhHxDvSGWLO4lSk/QWWSCqW+1ovUjB3NiedieO30T
 lh1kx+AIXXs6Gqo0J0JFp4Wc0EMtOWHdTIApUf13B2Sqom69sbpnkJOq278L4Vy/5rFG
 k9mGeZRiLb/jSO7XVsv54JDWjM3qaLpZCH8MfvWd2y0wXbGutRcINvN5ZhmIZYiotpMn
 +fiA==
MIME-Version: 1.0
X-Received: by 10.66.121.197 with SMTP id lm5mr37797323pab.118.1403066644377; 
 Tue, 17 Jun 2014 21:44:04 -0700 (PDT)
Received: by 10.70.4.1 with HTTP; Tue, 17 Jun 2014 21:44:04 -0700 (PDT)
In-Reply-To: <C341E36D-BBDF-49D4-BB24-C91E3F16281C@HIDDEN>
References: <874mzki66x.fsf@HIDDEN>
 <C341E36D-BBDF-49D4-BB24-C91E3F16281C@HIDDEN>
Date: Wed, 18 Jun 2014 12:44:04 +0800
Message-ID: <CAPtZNR0UT+uYTDmvLexjnKit9_=hTEEOQh_v8sWcE8BW0GNFCQ@HIDDEN>
Subject: Re: bug#17792: 24.3;
 hintstyle specified via fontconfig is ignored by Emacs
From: Fangwen Yu <yynyygy@HIDDEN>
To: =?UTF-8?Q?Jan_Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Content-Type: multipart/alternative; boundary=047d7b2e3e44ef380604fc14e8e1
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 17792
Cc: 17792 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

--047d7b2e3e44ef380604fc14e8e1
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

Clearly the fontconfig version on my system understands hint setting. As I
have said, if I have hintnone in fonts.conf and hintslight in X
resources, Emacs will use hintslight and all other gtk applications like
gedit, gnome-terminal will use hintnone.

Since Emacs is also a gtk application, why doesn't it respect fontconfig
settings?


On Tue, Jun 17, 2014 at 11:28 PM, Jan Dj=C3=A4rv <jan.h.d@HIDDEN> wrote=
:

> Hello.
>
> 17 jun 2014 kl. 05:08 skrev yynyygy@HIDDEN:
>
> > I've noticed font rendering differences between Emacs and other gtk
> > applications like gedit. In short, Emacs ignores hintstyle setting in
> > fontconfig. I have hintstyle set to hintslight in
> > ~/.config/fontconfig/fonts.conf, but I have to add 'Xft.hintstyle:
> > hintslight' in Xresources to get the desired effect.
> >
> > The strange thing is that while ignoring hintstyle setting, Emacs still
> > respect part of fontconfig settings, for example, anti-aliasing setting
> > in fonts.conf will affect Emacs's font rendering.
> >
>
> Hint setting is newer than the rest so it is possible your Emacs was
> compiled against a fontconfig that don't have it.
> Another possibility is that you have GSettings or GConf settings that are
> different than fonts.conf or from the X resources.
>
> Emacs by itself does not read fonts.conf or apply X resources, it is all
> done by fontconfig/Xft-libraries.  Emacs do apply GSettings and/or GConf
> settings.
>
>         Jan D.
>
>
> > To be more precise, if I disable anti-aliasing in fonts.conf and enable
> > it in Xresources, Emacs will not have anti-aliasing; if I have
> > hintslight in fonts.conf and hintnone in Xresources, Emacs will use
> > hintnone.
> >
> > I have tested with DejaVu Sans Mono 12 and Ubuntu Mono 13, but clearly
> > it is not the fonts' problem.
> >
> >
> > In GNU Emacs 24.3.1 (x86_64-pc-linux-gnu, GTK+ Version 3.10.8)
> > of 2014-06-11 on gentoo
> > Windowing system distributor `The X.Org Foundation', version
> 11.0.11500000
> > System Description:   NAME=3DGentoo
> >
> > Configured using:
> > `configure '--prefix=3D/usr' '--build=3Dx86_64-pc-linux-gnu'
> > '--host=3Dx86_64-pc-linux-gnu' '--mandir=3D/usr/share/man'
> > '--infodir=3D/usr/share/info' '--datadir=3D/usr/share' '--sysconfdir=3D=
/etc'
> > '--localstatedir=3D/var/lib' '--libdir=3D/usr/lib64'
> > '--disable-silent-rules' '--disable-dependency-tracking'
> > '--program-suffix=3D-emacs-24' '--infodir=3D/usr/share/info/emacs-24'
> > '--localstatedir=3D/var'
> > '--enable-locallisppath=3D/etc/emacs:/usr/share/emacs/site-lisp'
> > '--with-crt-dir=3D/usr/lib/gcc/x86_64-pc-linux-gnu/4.7.3/../../../../li=
b64'
> > '--with-gameuser=3Dgames' '--without-compress-info' '--without-hesiod'
> > '--without-kerberos' '--without-kerberos5' '--with-gpm' '--with-dbus'
> > '--without-gnutls' '--without-xml2' '--without-selinux'
> > '--without-wide-int' '--with-sound' '--with-x' '--without-ns'
> > '--without-gconf' '--without-gsettings' '--without-toolkit-scroll-bars'
> > '--with-gif' '--with-jpeg' '--with-png' '--with-rsvg' '--with-tiff'
> > '--with-xpm' '--without-imagemagick' '--with-xft' '--without-libotf'
> > '--without-m17n-flt' '--with-x-toolkit=3Dgtk3'
> > 'GENTOO_PACKAGE=3Dapp-editors/emacs-24.3-r6'
> > 'build_alias=3Dx86_64-pc-linux-gnu' 'host_alias=3Dx86_64-pc-linux-gnu'
> > 'CFLAGS=3D-march=3Dnative -O2 -pipe' 'LDFLAGS=3D-Wl,-O1 -Wl,--as-needed=
'
> > 'CPPFLAGS=3D''
> >
> > Important settings:
> >  value of $LC_COLLATE: C
> >  value of $LC_CTYPE: zh_CN.UTF-8
> >  value of $LANG: en_US.UTF-8
> >  value of $XMODIFIERS: @im=3Dfcitx
> >  locale-coding-system: utf-8-unix
> >  default enable-multibyte-characters: t
> >
> > Major mode: Lisp Interaction
> >
> > Minor modes in effect:
> >  tooltip-mode: t
> >  mouse-wheel-mode: t
> >  tool-bar-mode: t
> >  menu-bar-mode: t
> >  file-name-shadow-mode: t
> >  global-font-lock-mode: t
> >  font-lock-mode: t
> >  blink-cursor-mode: t
> >  auto-composition-mode: t
> >  auto-encryption-mode: t
> >  auto-compression-mode: t
> >  line-number-mode: t
> >  transient-mark-mode: t
> >
> > Recent input:
> > M-x r e p o r <tab> <return> C-y <backspace> <backspace>
> > M-x M-p <return>
> >
> > Recent messages:
> > For information about GNU Emacs and the GNU system, type C-h C-a.
> > current-kill: Kill ring is empty
> > delete-backward-char: Text is read-only [2 times]
> > Quit
> >
> > Load-path shadows:
> > None found.
> >
> > Features:
> > (shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 mm=
l
> > easymenu mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231
> > mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums
> > mm-util mail-prsvr mail-utils time-date china-util tooltip ediff-hook
> > vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar dnd fontset image
> > regexp-opt fringe tabulated-list newcomment lisp-mode register page
> > menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock font-lock
> > syntax facemenu font-core frame cham georgian utf-8-lang misc-lang
> > vietnamese tibetan thai tai-viet lao korean japanese hebrew greek
> > romanian slovak czech european ethiopic indian cyrillic chinese
> > case-table epa-hook jka-cmpr-hook help simple abbrev minibuffer loaddef=
s
> > button faces cus-face macroexp files text-properties overlay sha1 md5
> > base64 format env code-pages mule custom widget hashtable-print-readabl=
e
> > backquote make-network-process dbusbind dynamic-setting
> > font-render-setting move-toolbar gtk x-toolkit x multi-tty emacs)
> >
> >
>
>

--047d7b2e3e44ef380604fc14e8e1
Content-Type: text/html; charset=UTF-8
Content-Transfer-Encoding: quoted-printable

<div dir=3D"ltr">Clearly the fontconfig version on my system understands hi=
nt setting. As I have said, if I have hintnone in fonts.conf and hintslight=
 in X resources,=C2=A0Emacs will use hintslight and=C2=A0all=C2=A0other gtk=
 applications like gedit, gnome-terminal will use hintnone.<div>
<br></div><div>Since Emacs is also a gtk application, why doesn&#39;t it re=
spect fontconfig settings?</div></div><div class=3D"gmail_extra"><br><br><d=
iv class=3D"gmail_quote">On Tue, Jun 17, 2014 at 11:28 PM, Jan Dj=C3=A4rv <=
span dir=3D"ltr">&lt;<a href=3D"mailto:jan.h.d@HIDDEN" target=3D"_blank=
">jan.h.d@HIDDEN</a>&gt;</span> wrote:<br>
<blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1p=
x #ccc solid;padding-left:1ex">Hello.<br>
<br>
17 jun 2014 kl. 05:08 skrev <a href=3D"mailto:yynyygy@HIDDEN">yynyygy@gm=
ail.com</a>:<br>
<br>
&gt; I&#39;ve noticed font rendering differences between Emacs and other gt=
k<br>
&gt; applications like gedit. In short, Emacs ignores hintstyle setting in<=
br>
&gt; fontconfig. I have hintstyle set to hintslight in<br>
&gt; ~/.config/fontconfig/fonts.conf, but I have to add &#39;Xft.hintstyle:=
<br>
&gt; hintslight&#39; in Xresources to get the desired effect.<br>
&gt;<br>
&gt; The strange thing is that while ignoring hintstyle setting, Emacs stil=
l<br>
&gt; respect part of fontconfig settings, for example, anti-aliasing settin=
g<br>
&gt; in fonts.conf will affect Emacs&#39;s font rendering.<br>
&gt;<br>
<br>
Hint setting is newer than the rest so it is possible your Emacs was compil=
ed against a fontconfig that don&#39;t have it.<br>
Another possibility is that you have GSettings or GConf settings that are d=
ifferent than fonts.conf or from the X resources.<br>
<br>
Emacs by itself does not read fonts.conf or apply X resources, it is all do=
ne by fontconfig/Xft-libraries. =C2=A0Emacs do apply GSettings and/or GConf=
 settings.<br>
<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 Jan D.<br>
<br>
<br>
&gt; To be more precise, if I disable anti-aliasing in fonts.conf and enabl=
e<br>
&gt; it in Xresources, Emacs will not have anti-aliasing; if I have<br>
&gt; hintslight in fonts.conf and hintnone in Xresources, Emacs will use<br=
>
&gt; hintnone.<br>
&gt;<br>
&gt; I have tested with DejaVu Sans Mono 12 and Ubuntu Mono 13, but clearly=
<br>
&gt; it is not the fonts&#39; problem.<br>
&gt;<br>
&gt;<br>
&gt; In GNU Emacs 24.3.1 (x86_64-pc-linux-gnu, GTK+ Version 3.10.8)<br>
&gt; of 2014-06-11 on gentoo<br>
&gt; Windowing system distributor `The X.Org Foundation&#39;, version 11.0.=
11500000<br>
&gt; System Description: =C2=A0 NAME=3DGentoo<br>
&gt;<br>
&gt; Configured using:<br>
&gt; `configure &#39;--prefix=3D/usr&#39; &#39;--build=3Dx86_64-pc-linux-gn=
u&#39;<br>
&gt; &#39;--host=3Dx86_64-pc-linux-gnu&#39; &#39;--mandir=3D/usr/share/man&=
#39;<br>
&gt; &#39;--infodir=3D/usr/share/info&#39; &#39;--datadir=3D/usr/share&#39;=
 &#39;--sysconfdir=3D/etc&#39;<br>
&gt; &#39;--localstatedir=3D/var/lib&#39; &#39;--libdir=3D/usr/lib64&#39;<b=
r>
&gt; &#39;--disable-silent-rules&#39; &#39;--disable-dependency-tracking&#3=
9;<br>
&gt; &#39;--program-suffix=3D-emacs-24&#39; &#39;--infodir=3D/usr/share/inf=
o/emacs-24&#39;<br>
&gt; &#39;--localstatedir=3D/var&#39;<br>
&gt; &#39;--enable-locallisppath=3D/etc/emacs:/usr/share/emacs/site-lisp&#3=
9;<br>
&gt; &#39;--with-crt-dir=3D/usr/lib/gcc/x86_64-pc-linux-gnu/4.7.3/../../../=
../lib64&#39;<br>
&gt; &#39;--with-gameuser=3Dgames&#39; &#39;--without-compress-info&#39; &#=
39;--without-hesiod&#39;<br>
&gt; &#39;--without-kerberos&#39; &#39;--without-kerberos5&#39; &#39;--with=
-gpm&#39; &#39;--with-dbus&#39;<br>
&gt; &#39;--without-gnutls&#39; &#39;--without-xml2&#39; &#39;--without-sel=
inux&#39;<br>
&gt; &#39;--without-wide-int&#39; &#39;--with-sound&#39; &#39;--with-x&#39;=
 &#39;--without-ns&#39;<br>
&gt; &#39;--without-gconf&#39; &#39;--without-gsettings&#39; &#39;--without=
-toolkit-scroll-bars&#39;<br>
&gt; &#39;--with-gif&#39; &#39;--with-jpeg&#39; &#39;--with-png&#39; &#39;-=
-with-rsvg&#39; &#39;--with-tiff&#39;<br>
&gt; &#39;--with-xpm&#39; &#39;--without-imagemagick&#39; &#39;--with-xft&#=
39; &#39;--without-libotf&#39;<br>
&gt; &#39;--without-m17n-flt&#39; &#39;--with-x-toolkit=3Dgtk3&#39;<br>
&gt; &#39;GENTOO_PACKAGE=3Dapp-editors/emacs-24.3-r6&#39;<br>
&gt; &#39;build_alias=3Dx86_64-pc-linux-gnu&#39; &#39;host_alias=3Dx86_64-p=
c-linux-gnu&#39;<br>
&gt; &#39;CFLAGS=3D-march=3Dnative -O2 -pipe&#39; &#39;LDFLAGS=3D-Wl,-O1 -W=
l,--as-needed&#39;<br>
&gt; &#39;CPPFLAGS=3D&#39;&#39;<br>
&gt;<br>
&gt; Important settings:<br>
&gt; =C2=A0value of $LC_COLLATE: C<br>
&gt; =C2=A0value of $LC_CTYPE: zh_CN.UTF-8<br>
&gt; =C2=A0value of $LANG: en_US.UTF-8<br>
&gt; =C2=A0value of $XMODIFIERS: @im=3Dfcitx<br>
&gt; =C2=A0locale-coding-system: utf-8-unix<br>
&gt; =C2=A0default enable-multibyte-characters: t<br>
&gt;<br>
&gt; Major mode: Lisp Interaction<br>
&gt;<br>
&gt; Minor modes in effect:<br>
&gt; =C2=A0tooltip-mode: t<br>
&gt; =C2=A0mouse-wheel-mode: t<br>
&gt; =C2=A0tool-bar-mode: t<br>
&gt; =C2=A0menu-bar-mode: t<br>
&gt; =C2=A0file-name-shadow-mode: t<br>
&gt; =C2=A0global-font-lock-mode: t<br>
&gt; =C2=A0font-lock-mode: t<br>
&gt; =C2=A0blink-cursor-mode: t<br>
&gt; =C2=A0auto-composition-mode: t<br>
&gt; =C2=A0auto-encryption-mode: t<br>
&gt; =C2=A0auto-compression-mode: t<br>
&gt; =C2=A0line-number-mode: t<br>
&gt; =C2=A0transient-mark-mode: t<br>
&gt;<br>
&gt; Recent input:<br>
&gt; M-x r e p o r &lt;tab&gt; &lt;return&gt; C-y &lt;backspace&gt; &lt;bac=
kspace&gt;<br>
&gt; M-x M-p &lt;return&gt;<br>
&gt;<br>
&gt; Recent messages:<br>
&gt; For information about GNU Emacs and the GNU system, type C-h C-a.<br>
&gt; current-kill: Kill ring is empty<br>
&gt; delete-backward-char: Text is read-only [2 times]<br>
&gt; Quit<br>
&gt;<br>
&gt; Load-path shadows:<br>
&gt; None found.<br>
&gt;<br>
&gt; Features:<br>
&gt; (shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 m=
ml<br>
&gt; easymenu mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231<br>
&gt; mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums<br=
>
&gt; mm-util mail-prsvr mail-utils time-date china-util tooltip ediff-hook<=
br>
&gt; vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar dnd fontset image=
<br>
&gt; regexp-opt fringe tabulated-list newcomment lisp-mode register page<br=
>
&gt; menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock font-lock<=
br>
&gt; syntax facemenu font-core frame cham georgian utf-8-lang misc-lang<br>
&gt; vietnamese tibetan thai tai-viet lao korean japanese hebrew greek<br>
&gt; romanian slovak czech european ethiopic indian cyrillic chinese<br>
&gt; case-table epa-hook jka-cmpr-hook help simple abbrev minibuffer loadde=
fs<br>
&gt; button faces cus-face macroexp files text-properties overlay sha1 md5<=
br>
&gt; base64 format env code-pages mule custom widget hashtable-print-readab=
le<br>
&gt; backquote make-network-process dbusbind dynamic-setting<br>
&gt; font-render-setting move-toolbar gtk x-toolkit x multi-tty emacs)<br>
&gt;<br>
&gt;<br>
<br>
</blockquote></div><br></div>

--047d7b2e3e44ef380604fc14e8e1--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#17792; Package emacs. Full text available.

Message received at 17792 <at> debbugs.gnu.org:


Received: (at 17792) by debbugs.gnu.org; 17 Jun 2014 15:28:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jun 17 11:28:31 2014
Received: from localhost ([127.0.0.1]:50778 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1WwvJC-0004sG-Li
	for submit <at> debbugs.gnu.org; Tue, 17 Jun 2014 11:28:31 -0400
Received: from mailfe04.swip.net ([212.247.154.97]:41406 helo=swip.net)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <jan.h.d@HIDDEN>) id 1WwvJ6-0004ru-BT
 for 17792 <at> debbugs.gnu.org; Tue, 17 Jun 2014 11:28:25 -0400
X-T2-Spam-Status: No, hits=0.0 required=5.0
Received: from hosdjarv.se (account mj138573@HIDDEN [46.59.42.57] verified)
 by mailfe04.swip.net (CommuniGate Pro SMTP 5.4.4)
 with ESMTPA id 508406016; Tue, 17 Jun 2014 17:28:13 +0200
Received: from c-178-73-202-221.anonymous.at.anonine.com (unknown
 [178.73.202.221]) (Authenticated sender: jhd)
 by hosdjarv.se (Postfix) with ESMTPSA id 1DA7D1A024E;
 Tue, 17 Jun 2014 15:28:11 +0000 (UTC)
Content-Type: text/plain; charset=us-ascii
Mime-Version: 1.0 (Mac OS X Mail 7.3 \(1878.2\))
Subject: Re: bug#17792: 24.3;
 hintstyle specified via fontconfig is ignored by Emacs
From: =?iso-8859-1?Q?Jan_Dj=E4rv?= <jan.h.d@HIDDEN>
In-Reply-To: <874mzki66x.fsf@HIDDEN>
Date: Tue, 17 Jun 2014 17:28:10 +0200
Content-Transfer-Encoding: quoted-printable
Message-Id: <C341E36D-BBDF-49D4-BB24-C91E3F16281C@HIDDEN>
References: <874mzki66x.fsf@HIDDEN>
To: yynyygy@HIDDEN
X-Mailer: Apple Mail (2.1878.2)
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 17792
Cc: 17792 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.0 (/)

Hello.

17 jun 2014 kl. 05:08 skrev yynyygy@HIDDEN:

> I've noticed font rendering differences between Emacs and other gtk
> applications like gedit. In short, Emacs ignores hintstyle setting in
> fontconfig. I have hintstyle set to hintslight in
> ~/.config/fontconfig/fonts.conf, but I have to add 'Xft.hintstyle:
> hintslight' in Xresources to get the desired effect.
>=20
> The strange thing is that while ignoring hintstyle setting, Emacs =
still
> respect part of fontconfig settings, for example, anti-aliasing =
setting
> in fonts.conf will affect Emacs's font rendering.
>=20

Hint setting is newer than the rest so it is possible your Emacs was =
compiled against a fontconfig that don't have it.
Another possibility is that you have GSettings or GConf settings that =
are different than fonts.conf or from the X resources.

Emacs by itself does not read fonts.conf or apply X resources, it is all =
done by fontconfig/Xft-libraries.  Emacs do apply GSettings and/or GConf =
settings.

	Jan D.


> To be more precise, if I disable anti-aliasing in fonts.conf and =
enable
> it in Xresources, Emacs will not have anti-aliasing; if I have
> hintslight in fonts.conf and hintnone in Xresources, Emacs will use
> hintnone.
>=20
> I have tested with DejaVu Sans Mono 12 and Ubuntu Mono 13, but clearly
> it is not the fonts' problem.
>=20
>=20
> In GNU Emacs 24.3.1 (x86_64-pc-linux-gnu, GTK+ Version 3.10.8)
> of 2014-06-11 on gentoo
> Windowing system distributor `The X.Org Foundation', version =
11.0.11500000
> System Description:	NAME=3DGentoo
>=20
> Configured using:
> `configure '--prefix=3D/usr' '--build=3Dx86_64-pc-linux-gnu'
> '--host=3Dx86_64-pc-linux-gnu' '--mandir=3D/usr/share/man'
> '--infodir=3D/usr/share/info' '--datadir=3D/usr/share' =
'--sysconfdir=3D/etc'
> '--localstatedir=3D/var/lib' '--libdir=3D/usr/lib64'
> '--disable-silent-rules' '--disable-dependency-tracking'
> '--program-suffix=3D-emacs-24' '--infodir=3D/usr/share/info/emacs-24'
> '--localstatedir=3D/var'
> '--enable-locallisppath=3D/etc/emacs:/usr/share/emacs/site-lisp'
> =
'--with-crt-dir=3D/usr/lib/gcc/x86_64-pc-linux-gnu/4.7.3/../../../../lib64=
'
> '--with-gameuser=3Dgames' '--without-compress-info' '--without-hesiod'
> '--without-kerberos' '--without-kerberos5' '--with-gpm' '--with-dbus'
> '--without-gnutls' '--without-xml2' '--without-selinux'
> '--without-wide-int' '--with-sound' '--with-x' '--without-ns'
> '--without-gconf' '--without-gsettings' =
'--without-toolkit-scroll-bars'
> '--with-gif' '--with-jpeg' '--with-png' '--with-rsvg' '--with-tiff'
> '--with-xpm' '--without-imagemagick' '--with-xft' '--without-libotf'
> '--without-m17n-flt' '--with-x-toolkit=3Dgtk3'
> 'GENTOO_PACKAGE=3Dapp-editors/emacs-24.3-r6'
> 'build_alias=3Dx86_64-pc-linux-gnu' 'host_alias=3Dx86_64-pc-linux-gnu'
> 'CFLAGS=3D-march=3Dnative -O2 -pipe' 'LDFLAGS=3D-Wl,-O1 =
-Wl,--as-needed'
> 'CPPFLAGS=3D''
>=20
> Important settings:
>  value of $LC_COLLATE: C
>  value of $LC_CTYPE: zh_CN.UTF-8
>  value of $LANG: en_US.UTF-8
>  value of $XMODIFIERS: @im=3Dfcitx
>  locale-coding-system: utf-8-unix
>  default enable-multibyte-characters: t
>=20
> Major mode: Lisp Interaction
>=20
> Minor modes in effect:
>  tooltip-mode: t
>  mouse-wheel-mode: t
>  tool-bar-mode: t
>  menu-bar-mode: t
>  file-name-shadow-mode: t
>  global-font-lock-mode: t
>  font-lock-mode: t
>  blink-cursor-mode: t
>  auto-composition-mode: t
>  auto-encryption-mode: t
>  auto-compression-mode: t
>  line-number-mode: t
>  transient-mark-mode: t
>=20
> Recent input:
> M-x r e p o r <tab> <return> C-y <backspace> <backspace>=20
> M-x M-p <return>
>=20
> Recent messages:
> For information about GNU Emacs and the GNU system, type C-h C-a.
> current-kill: Kill ring is empty
> delete-backward-char: Text is read-only [2 times]
> Quit
>=20
> Load-path shadows:
> None found.
>=20
> Features:
> (shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 =
mml
> easymenu mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231
> mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums
> mm-util mail-prsvr mail-utils time-date china-util tooltip ediff-hook
> vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar dnd fontset image
> regexp-opt fringe tabulated-list newcomment lisp-mode register page
> menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock font-lock
> syntax facemenu font-core frame cham georgian utf-8-lang misc-lang
> vietnamese tibetan thai tai-viet lao korean japanese hebrew greek
> romanian slovak czech european ethiopic indian cyrillic chinese
> case-table epa-hook jka-cmpr-hook help simple abbrev minibuffer =
loaddefs
> button faces cus-face macroexp files text-properties overlay sha1 md5
> base64 format env code-pages mule custom widget =
hashtable-print-readable
> backquote make-network-process dbusbind dynamic-setting
> font-render-setting move-toolbar gtk x-toolkit x multi-tty emacs)
>=20
>=20





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#17792; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 17 Jun 2014 03:09:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jun 16 23:09:50 2014
Received: from localhost ([127.0.0.1]:49830 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.80)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1WwjmP-0007kH-EY
	for submit <at> debbugs.gnu.org; Mon, 16 Jun 2014 23:09:49 -0400
Received: from eggs.gnu.org ([208.118.235.92]:40629)
 by debbugs.gnu.org with esmtp (Exim 4.80)
 (envelope-from <yynyygy@HIDDEN>) id 1WwjmM-0007jz-DQ
 for submit <at> debbugs.gnu.org; Mon, 16 Jun 2014 23:09:47 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <yynyygy@HIDDEN>) id 1WwjmF-0003Zm-Vf
 for submit <at> debbugs.gnu.org; Mon, 16 Jun 2014 23:09:41 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 T_DKIM_INVALID autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:51376)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <yynyygy@HIDDEN>) id 1WwjmF-0003Zi-SA
 for submit <at> debbugs.gnu.org; Mon, 16 Jun 2014 23:09:39 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:42351)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <yynyygy@HIDDEN>) id 1WwjmE-0003b4-Oz
 for bug-gnu-emacs@HIDDEN; Mon, 16 Jun 2014 23:09:39 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <yynyygy@HIDDEN>) id 1WwjmD-0003ZS-CQ
 for bug-gnu-emacs@HIDDEN; Mon, 16 Jun 2014 23:09:38 -0400
Received: from mail-pa0-x235.google.com ([2607:f8b0:400e:c03::235]:56887)
 by eggs.gnu.org with esmtp (Exim 4.71)
 (envelope-from <yynyygy@HIDDEN>) id 1WwjmD-0003ZM-2J
 for bug-gnu-emacs@HIDDEN; Mon, 16 Jun 2014 23:09:37 -0400
Received: by mail-pa0-f53.google.com with SMTP id ey11so1708587pad.26
 for <bug-gnu-emacs@HIDDEN>; Mon, 16 Jun 2014 20:09:35 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
 h=from:to:subject:date:message-id:mime-version:content-type;
 bh=pW+60iG/PPXsPnLmfw0Km75BwavalLhvMr5xekEBsxc=;
 b=yu4H/DYlcAROB8z+5sXGGdstgCyCNlA3yc1QhTTkGbJwXUKaH9Z4AjYVYNSlljWbzK
 eIxjOTrh9wcjz9IR4hudYKZ+W8sOP28QiVOBXjKxxsxLf6SG61fcHOHnhmcAlRmK9pSL
 ahK+NyUfRe2sbn70OD316WUg9v0oZoc7BhsoO7zXoJPgRjOl+OxLs3eKAIHG//D5BWIC
 0abHLF6aWFoE2+dGMNOellLsfZyOQQNInZt0SvQ6cxnZLGFPzvIWFBdknLwo/k5R8Gls
 ZsrWR+1FpPPXyzT3GY6WT4PxQHgNjPMxTyFAsPRivJvaedcyJcWPjVc8hrbIk8vqPBNs
 eAqg==
X-Received: by 10.66.66.202 with SMTP id h10mr28988332pat.70.1402974575624;
 Mon, 16 Jun 2014 20:09:35 -0700 (PDT)
Received: from gentoo ([2001:250:401:1172:9a4b:e1ff:feb8:30d8])
 by mx.google.com with ESMTPSA id qf10sm21280354pbc.23.2014.06.16.20.09.33
 for <bug-gnu-emacs@HIDDEN>
 (version=TLSv1.2 cipher=RC4-SHA bits=128/128);
 Mon, 16 Jun 2014 20:09:35 -0700 (PDT)
From: yynyygy@HIDDEN
To: bug-gnu-emacs@HIDDEN
Subject: 24.3; hintstyle specified via fontconfig is ignored by Emacs
Date: Tue, 17 Jun 2014 11:08:22 +0800
Message-ID: <874mzki66x.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-detected-operating-system: by eggs.gnu.org: Error: Malformed IPv6 address
 (bad octet value).
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.15
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -4.0 (----)

I've noticed font rendering differences between Emacs and other gtk
applications like gedit. In short, Emacs ignores hintstyle setting in
fontconfig. I have hintstyle set to hintslight in
~/.config/fontconfig/fonts.conf, but I have to add 'Xft.hintstyle:
hintslight' in Xresources to get the desired effect.

The strange thing is that while ignoring hintstyle setting, Emacs still
respect part of fontconfig settings, for example, anti-aliasing setting
in fonts.conf will affect Emacs's font rendering.

To be more precise, if I disable anti-aliasing in fonts.conf and enable
it in Xresources, Emacs will not have anti-aliasing; if I have
hintslight in fonts.conf and hintnone in Xresources, Emacs will use
hintnone.

I have tested with DejaVu Sans Mono 12 and Ubuntu Mono 13, but clearly
it is not the fonts' problem.


In GNU Emacs 24.3.1 (x86_64-pc-linux-gnu, GTK+ Version 3.10.8)
 of 2014-06-11 on gentoo
Windowing system distributor `The X.Org Foundation', version 11.0.11500000
System Description:	NAME=Gentoo

Configured using:
 `configure '--prefix=/usr' '--build=x86_64-pc-linux-gnu'
 '--host=x86_64-pc-linux-gnu' '--mandir=/usr/share/man'
 '--infodir=/usr/share/info' '--datadir=/usr/share' '--sysconfdir=/etc'
 '--localstatedir=/var/lib' '--libdir=/usr/lib64'
 '--disable-silent-rules' '--disable-dependency-tracking'
 '--program-suffix=-emacs-24' '--infodir=/usr/share/info/emacs-24'
 '--localstatedir=/var'
 '--enable-locallisppath=/etc/emacs:/usr/share/emacs/site-lisp'
 '--with-crt-dir=/usr/lib/gcc/x86_64-pc-linux-gnu/4.7.3/../../../../lib64'
 '--with-gameuser=games' '--without-compress-info' '--without-hesiod'
 '--without-kerberos' '--without-kerberos5' '--with-gpm' '--with-dbus'
 '--without-gnutls' '--without-xml2' '--without-selinux'
 '--without-wide-int' '--with-sound' '--with-x' '--without-ns'
 '--without-gconf' '--without-gsettings' '--without-toolkit-scroll-bars'
 '--with-gif' '--with-jpeg' '--with-png' '--with-rsvg' '--with-tiff'
 '--with-xpm' '--without-imagemagick' '--with-xft' '--without-libotf'
 '--without-m17n-flt' '--with-x-toolkit=gtk3'
 'GENTOO_PACKAGE=app-editors/emacs-24.3-r6'
 'build_alias=x86_64-pc-linux-gnu' 'host_alias=x86_64-pc-linux-gnu'
 'CFLAGS=-march=native -O2 -pipe' 'LDFLAGS=-Wl,-O1 -Wl,--as-needed'
 'CPPFLAGS=''

Important settings:
  value of $LC_COLLATE: C
  value of $LC_CTYPE: zh_CN.UTF-8
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: @im=fcitx
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
M-x r e p o r <tab> <return> C-y <backspace> <backspace> 
M-x M-p <return>

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.
current-kill: Kill ring is empty
delete-backward-char: Text is read-only [2 times]
Quit

Load-path shadows:
None found.

Features:
(shadow sort gnus-util mail-extr emacsbug message format-spec rfc822 mml
easymenu mml-sec mm-decode mm-bodies mm-encode mail-parse rfc2231
mailabbrev gmm-utils mailheader sendmail rfc2047 rfc2045 ietf-drums
mm-util mail-prsvr mail-utils time-date china-util tooltip ediff-hook
vc-hooks lisp-float-type mwheel x-win x-dnd tool-bar dnd fontset image
regexp-opt fringe tabulated-list newcomment lisp-mode register page
menu-bar rfn-eshadow timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core frame cham georgian utf-8-lang misc-lang
vietnamese tibetan thai tai-viet lao korean japanese hebrew greek
romanian slovak czech european ethiopic indian cyrillic chinese
case-table epa-hook jka-cmpr-hook help simple abbrev minibuffer loaddefs
button faces cus-face macroexp files text-properties overlay sha1 md5
base64 format env code-pages mule custom widget hashtable-print-readable
backquote make-network-process dbusbind dynamic-setting
font-render-setting move-toolbar gtk x-toolkit x multi-tty emacs)




Acknowledgement sent to yynyygy@HIDDEN:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#17792; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.